#include "agent.h"
#include "special_positions.h"
#include <stdio.h>
#include <stream.h>
#include <unistd.h>
#include <signal.h>
#include <sys/time.h>

#include "Configuration.h"

#define STEPS_PER_100_MS 2

static long probstate[32] = {
  3,
  0x9a319039, 0x32d9c024, 0x9b663182, 0x5da1f342,
  0x7449e56b, 0xbeb1dbb0, 0xab5c5918, 0x946554fd,
  0x8c2e680f, 0xeb3d799f, 0xb11ee0b7, 0x2d436b86,
  0xda672e2a, 0x1588ca88, 0xe369735d, 0x904f35f7,
  0xd7158fd6, 0x6fa6f051, 0x616e6b96, 0xac94efdc,
  0xde3b81e0, 0xdf0a6fb5, 0xf103bc02, 0x48f340fb,
  0x36413f93, 0xc622c298, 0xf5a42ab8, 0x8a88d77b,
  0xf5ad9d0e, 0x8999220b, 0x27fb47b9
};

Agent* TheAgent;

void Agent::NervTransmission (int signo)
{
  TheAgent->m_cSensorik->getSensorInfo (); 
  if (TheAgent->m_nCounter==1) 
    TheAgent->m_cSender->SendCommand ();
  TheAgent->m_nCounter = (TheAgent->m_nCounter+1)%STEPS_PER_100_MS;

}

char row[254];

char* ReadConfStr (FILE* input)
{

  fgets (row, 254, input);
  sscanf (row, "%[^\n]", row);
  while (row [0]=='/' || row [0]=='\n' || row [0]==' ')
  {
    fgets (row, 254, input);
    sscanf (row, "%[^\n]", row);
  }
  return row;
}

//Agent::Agent (char* host, int port, char* teamname, char* aufstellung)
//fuer die Cebit (char* configfile);
Agent::Agent (int argc, char* argv [])
{
  int after_halftime = 0;
  // Zufallszahlengenerator initialisieren;
  unsigned seed = 1;
  int n = 128;
  initstate (seed, (char*)probstate, n);
  setstate ((char*)probstate);
  
  m_nCounter = 0;
  m_cWeltmodell = &weltmodell;

  /////////////////////////////////////////;
  //--------- server.conf lesen;
  globalConf = new Configuration();
  globalConf->readConfigurationFile("server.conf");
  
  /////////////////////////////////////////;
  //--------- Config-File lesen;
  FILE* input;
  char host [30];
  int port;
  char team [30];
  int playernumber;
  int role, width, qual;
  double dashRefuseFactor;
  double xpos, ypos;
  double xposStart, yposStart,xposStart2, yposStart2;
  double xposCorner, yposCorner;
  double xposGoal, yposGoal;
  double bestFactor, meanFactor;
  
  input = fopen (argv [1], "rt");
  //strcpy (host, ReadConfStr (input));
  strcpy(host, argv[2]);
  //port = atoi (ReadConfStr (input));
  port = DEFAULT_PORT_NUMBER;
  strcpy(team,"AT_Humboldt97");
  //playernumber = atoi (ReadConfStr (input));
  if (argc == 3) {
    playernumber = 0;
  }
  else {
    playernumber = atoi(argv[3]);
  }

  width = atoi (ReadConfStr (input));
  // width = 2;
  qual = atoi (ReadConfStr (input));
  // qual = 1;
  m_cWeltmodell->setze_sicht_breite (width);
  m_cWeltmodell->setze_sicht_qualitaet (qual);

  dashRefuseFactor= atof (ReadConfStr (input));
  globalConf->staminaDashIgnoreThr = dashRefuseFactor * globalConf->playerStaminaMax;

  globalConf->kickDirIgnoreOurPlayerDist= atof (ReadConfStr (input));
  globalConf->kickDirIgnoreOurPlayerDir= atof (ReadConfStr (input));
  globalConf->kickDirIgnoreTheirPlayerDist= atof (ReadConfStr (input));
  globalConf->kickDirIgnoreTheirPlayerDir= atof (ReadConfStr (input));

  role = atoi (ReadConfStr (input));
  xposStart = atof (ReadConfStr (input));
  yposStart = atof (ReadConfStr (input));
  xposStart2 = atof (ReadConfStr (input));
  yposStart2 = atof (ReadConfStr (input));
  xpos = atof (ReadConfStr (input));
  ypos = atof (ReadConfStr (input));
  //xposCorner = atof (ReadConfStr (input));
  //yposCorner = atof (ReadConfStr (input));
  //xposCorner= atof (ReadConfStr (input));
  //yposCorner = atof (ReadConfStr (input));
  //  xposGoal = atof (ReadConfStr (input));
  //  yposGoal = atof (ReadConfStr (input));
  xposCorner=xpos;
  yposCorner=ypos;
  xposGoal = xpos;
  yposGoal = ypos;
  m_cWeltmodell->setze_param (0, atof (ReadConfStr (input)));
  m_cWeltmodell->setze_param (1, atof (ReadConfStr (input)));
  m_cWeltmodell->setze_param (2, atof (ReadConfStr (input)));
  bestFactor = atof (ReadConfStr (input));
  if(bestFactor > 1.0) bestFactor = 1.0;
  if(bestFactor < 0.0) bestFactor = 0.0;
  m_cWeltmodell->setze_param (3, bestFactor);
  meanFactor = 1-bestFactor;
  m_cWeltmodell->setze_param (4, meanFactor);
  m_cWeltmodell->setze_param (5, atof (ReadConfStr (input)));
  fclose (input);
  /////////////////////////////////////////;
  
  // Organe anschmeissen ///////////////////////////////////////;
  m_cCommunication = new Comm (host, port);
  m_cCommunication->SetProtocol (0);
//	m_cCommunication->SetProtocol (1);
  
  m_cSkills = new BaseSkills (m_cCommunication);
  m_cSense = new Sensors (m_cCommunication);
  if (playernumber == 0)
    m_cSkills->EnterField (team);
  else
    {
      m_cSkills->ReEnterField (team, playernumber);	
      after_halftime = 1;	
    }
  
  m_cWeltmodell->initialisiere_nummer (m_cSkills->GetPlayerNumber ());
  m_cWeltmodell->initialisiere_seite (m_cSkills->GetSide ());
  m_cWeltmodell->initialisiere_teamname (team);	
  m_cWeltmodell->setze_aufstellung (0);
  
  // fuer die Cebit;
  (InplayPositions [0] [m_cWeltmodell->frage_nummer ()]).position.x1 = xpos;
  (InplayPositions [0] [m_cWeltmodell->frage_nummer ()]).position.x2 = ypos;
  (InplayPositions [1] [m_cWeltmodell->frage_nummer ()]).position.x1 = xpos;
  (InplayPositions [1] [m_cWeltmodell->frage_nummer ()]).position.x2 = ypos;
  (InplayPositions [2] [m_cWeltmodell->frage_nummer ()]).position.x1 = xpos;
  (InplayPositions [2] [m_cWeltmodell->frage_nummer ()]).position.x2 = ypos;
  (CornerkickPositions [0] [m_cWeltmodell->frage_nummer ()]).x1 = xposCorner;
  (CornerkickPositions [0] [m_cWeltmodell->frage_nummer ()]).x2 = yposCorner;
  (CornerkickPositions [1] [m_cWeltmodell->frage_nummer ()]).x1 = xposCorner;
  (CornerkickPositions [1] [m_cWeltmodell->frage_nummer ()]).x2 = yposCorner;
  (GoalkickPositions [0] [m_cWeltmodell->frage_nummer ()]).x1 = xposGoal;
  (GoalkickPositions [0] [m_cWeltmodell->frage_nummer ()]).x2 = yposGoal;
  (GoalkickPositions [1] [m_cWeltmodell->frage_nummer ()]).x1 = xposGoal;
  (GoalkickPositions [1] [m_cWeltmodell->frage_nummer ()]).x2 = yposGoal;
  (KickoffPositions [0] [m_cWeltmodell->frage_nummer ()]).x1 = xposStart;
  (KickoffPositions [0] [m_cWeltmodell->frage_nummer ()]).x2 = yposStart;
  (KickoffPositions [1] [m_cWeltmodell->frage_nummer ()]).x1 = xposStart2;
  (KickoffPositions [1] [m_cWeltmodell->frage_nummer ()]).x2 = yposStart2;
  (InplayPositions [0] [m_cWeltmodell->frage_nummer ()]).rolle = role;
  
  if (after_halftime) // Setzen der internen Uhr
    {
      m_cSense->ListenAndWatch ();
#ifdef DEBUG
      cout << "Uhr: " << m_cSense->GetTime () << endl << flush;
#endif
      Uhr::setze_jetzt ((Zeit)m_cSense->GetTime ());
    }
  
  if (m_cSkills->GetSide () == 'l')
    m_cWeltmodell->setze_initiative (INITIATIVE_WIR);
  else
    m_cWeltmodell->setze_initiative (INITIATIVE_SIE);
  
  m_cSender = new Sender (m_cSkills);
  m_cSensorik = new Sensorik (m_cSense, m_cWeltmodell);
  
  m_cAdvSkills = new AdvancedSkills (m_cWeltmodell, m_cSender);
  m_cBrain = new Brain (m_cSensorik, m_cSense, m_cSender, m_cWeltmodell, m_cAdvSkills);
}

Agent::~Agent ()
{
  itimerval zeit;

  // SIGALARM abschalten
  zeit.it_value.tv_sec = 0;
  zeit.it_value.tv_usec = 0;
  zeit.it_interval.tv_sec = 0;
  zeit.it_interval.tv_usec = 0;
  setitimer (ITIMER_REAL, &zeit, NULL);

  // Signalbehandlung zuruecksetzen
  sigset_t mask;
  struct sigaction vec;
  sigemptyset (&mask);
  vec.sa_handler = SIG_DFL;
  vec.sa_mask = mask;
  vec.sa_flags = 0;
  sigaction (SIGALRM, &vec, NULL);  

  // Organe abschalten

	delete m_cBrain;
	delete m_cAdvSkills;
	delete m_cSender;
	delete m_cSensorik;
	delete m_cSkills;
	delete m_cSense;
	delete m_cCommunication;
}

void Agent::InitializeNervs ()
{
sigset_t mask;
struct sigaction vec;
	sigfillset (&mask);
	sigdelset (&mask, SIGINT);
	sigdelset (&mask, SIGTERM);
	vec.sa_handler = ((void (*) (int))NervTransmission);
	vec.sa_mask = mask;
	vec.sa_flags = 0;
	if (sigaction (SIGALRM, &vec, NULL) == -1) 
	{
		cerr << "signal (SIGALRM) error\n"; 
		exit(1);
	}

itimerval zeit;
	zeit.it_value.tv_sec = 0;
	zeit.it_value.tv_usec = 100000/STEPS_PER_100_MS;
	zeit.it_interval.tv_sec = 0;
	zeit.it_interval.tv_usec = 100000/STEPS_PER_100_MS;
	setitimer (ITIMER_REAL, &zeit, NULL);
}

void Agent::Run ()
{
	InitializeNervs ();
	m_cBrain->Think ();
	//m_cSkills->LeaveField (); // Server-Fehler
}

int main (int argc, char* argv [])
{
	//TheAgent = new Agent (argv [1], 6000, argv [2], argv [3]);
	TheAgent = new Agent (argc, argv);
	TheAgent->Run ();
}










