////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////  alinkel.h - Klasse fuer ein Element einer doppelt verketteten Liste
/////  Diese Klasse ist nicht public domain!
/////  Sie unterliegt dem Urheberrecht und Kopierrecht von 
/////  fa. dreisoft c/o Holger Dreissig und Markus Hannebauer.
/////  Sie ist nur fuer die Nutzung im Praktikum im SoSe 97 freigegeben..

#ifndef _ALINKELEM_H_
#define _ALINKELEM_H_
template <class T> class ALinkList;
template <class T>
class ALinkElem
{
friend class ALinkList<T>;

private:
	T* val;
	ALinkElem<T> *left, *right;

public:
  ALinkElem (); // Konstruktor
  ALinkElem (const ALinkElem<T> &x); // Kopierroutine
  ~ALinkElem (); // Destruktor
  ALinkElem & operator=(const ALinkElem<T> &x); // Zuweisungsoperator

  T* GetVal () const;
  void PutVal (T *x);
  ALinkElem<T>* GetRight () const;
  ALinkElem<T>* GetLeft () const;
  void PutRight (ALinkElem<T> *l);
  void PutLeft (ALinkElem<T> *l);
  void InsRight (T *x);
  void InsLeft (T *x);
  ALinkElem<T>* DelRight ();
  ALinkElem<T>* DelLeft ();
};

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////  alinkel.h - Implementierung einer Klasse fuer ein Element einer doppelt verketteten Liste

template <class T>
ALinkElem<T>::ALinkElem ()
{
  right = NULL;
  left = NULL;
}

template <class T>
ALinkElem<T>::ALinkElem (const ALinkElem<T> &x)
{
  val = x.val;
  left = x.left;
  right = x.right;
}

template <class T>
ALinkElem<T>::~ALinkElem ()
{
	// val wird nicht geloescht, muss vom Client geloescht werden
}

template <class T>
ALinkElem<T> & ALinkElem<T>::operator=(const ALinkElem<T> &x)
{
  if (&x!=this)
  {
    val = x.val;
    left = x.left;
    right = x.right;
  };
  return (*this);
}

template <class T>
T *ALinkElem<T>::GetVal () const
{
  return (val);
}

template <class T>
void ALinkElem<T>::PutVal (T *x)
{
  val = x;
}

template <class T>
ALinkElem<T> *ALinkElem<T>::GetRight () const
{
  return (right);
}

template <class T>
ALinkElem<T> *ALinkElem<T>::GetLeft () const
{
  return (left);
}

template <class T>
void ALinkElem<T>::PutRight (ALinkElem<T> *l)
{
  right = l;
}

template <class T>
void ALinkElem<T>::PutLeft (ALinkElem<T> *l)
{
  left = l;
}

template <class T>
void ALinkElem<T>::InsRight (T *x)
{
ALinkElem<T> *tmp;

  tmp = new ALinkElem<T>;
  tmp->PutVal (x);
  tmp->PutRight (right);
  right = tmp;
  right->PutLeft (this);
  if (right->GetRight () != NULL)
    right->GetRight ()->PutLeft (right);
}

template <class T>
void ALinkElem<T>::InsLeft (T *x)
{
ALinkElem<T> *tmp;

  tmp = new ALinkElem<T>;
  tmp->PutVal (x);
  tmp->PutLeft (left);
  left = tmp;
  left->PutRight (this);
  if (left->GetLeft () != NULL)
    left->GetLeft ()->PutRight (left);
}

template <class T>
ALinkElem<T> *ALinkElem<T>::DelRight ()
{
ALinkElem<T> *tmp;

  if (right == NULL)
    return (NULL);
  else
  {
    tmp = right;
    right = right->GetRight ();
    if (right != NULL)
      right->PutLeft (this);
    return (tmp); // mu vom Client gelscht werden
  }
}

template <class T>
ALinkElem<T> *ALinkElem<T>::DelLeft ()
{
ALinkElem<T> *tmp;

  if (left == NULL)
    return (NULL);
  else
  {
    tmp = left;
    left = left->GetLeft ();
    if (left != NULL)
      left->PutRight (this);
    return (tmp); // mu vom Client gelscht werden
  }
}

#endif
