//////////////////////////////////////////////////////////////////////
//  comm.h -- Klasse zur UDP-Socket-Kommunikation mit dem SoccerServer

#ifndef _COMM_H
#define _COMM_H

#if __GNUG__ >= 2
#  pragma interface
#endif

#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <fcntl.h>
#include <errno.h>
#include <stdio.h>

// for Linux
#include <sys/times.h>
#include <sys/time.h>

#define MAXMESG 4096

#define DEFAULT_PORT_NUMBER 	6000
#define WAIT_FOREVER -1
#define RECV_SUCCESS 1
#define RECV_NOMESSAGE -1
#define RECV_INTERRUPT -2
#define RECV_TIMEOUT -3
#define SEND_SUCCESS 	1
#define SEND_FAILED -1

class Comm
{
public:
	Comm (char* host, int port);
   ~Comm ();
   void SetProtocol (int bProtocol);
   
   int SendMessage (char* buf);
	int WaitForMessage (char* buf, int size, int secs, int usecs);
	int GetLastMessage (char* buf, int size);
   void CloseConnection ();

private:
	int m_bProtocol;
   int m_nSocketfd;
   struct sockaddr_in m_sServ_addr;
   int m_bClosed;
};

#endif
