// Klasse Sensor_Gesetzt

#include "commando.h"

const int gesetzt_ueberhaupt = 1;
const int gesetzt_p = 2;
const int gesetzt_v = 4;

class Sensor_Gesetzt
	{
protected:
	int		gesetzt;

public:
	inline Sensor_Gesetzt(void) {gesetzt = 0;}
	
	inline void setzen(void)		// Das Objekt wird als uberhaupt gesetzt angemeldet
		{gesetzt |= gesetzt_ueberhaupt;}
	inline void ruecksetzen(void)	// Alles auf nicht gesetzt
		{gesetzt = 0;}
	
	inline void p_ist_gesetzt(void)		// entsprechendes Flag setzen
		{gesetzt |= gesetzt_p;}
	inline void v_ist_gesetzt(void)
		{gesetzt |= gesetzt_v;}
	
	inline int ist_gesetzt(void) const	// Frage, ob uberhaupt ein Wert gesetzt ist
		{return gesetzt & gesetzt_ueberhaupt;}
	
	inline int ist_p_gesetzt(void) const		// entsprechendes Flag abfragen
		{return gesetzt & gesetzt_p;}
	inline int ist_v_gesetzt(void) const
		{return gesetzt & gesetzt_v;}
	};

// Klasse Relative_Geschwindigkeit

class Relative_Geschwindigkeit
	{
private:
	Geschwindigkeit			vr;

public:
	inline Relative_Geschwindigkeit(void)
		{vr.x1 = vr.x2 = 0;}
	
	inline void setze_vr(Geschwindigkeit neu) {vr = neu;}
	const Geschwindigkeit &frage_vr(void) const {return vr;}
	};

const int gesetzt_team = 8;
const int gesetzt_nummer = 16;

class Sensor_Spieler : public Spielerkennzeichnung, public Position,public Relative_Geschwindigkeit,
	public Sensor_Gesetzt
	{
public:
	inline void team_ist_gesetzt(void) {gesetzt |= gesetzt_team;}
	inline void nummer_ist_gesetzt(void) {gesetzt |= gesetzt_nummer;}
	
	inline int ist_team_gesetzt(void) const {return gesetzt & gesetzt_team;}
	inline int ist_nummer_gesetzt(void) const {return gesetzt & gesetzt_nummer;}
	};

// Klasse Sensor_Ball

class Sensor_Ball : public Position, public Relative_Geschwindigkeit, public Sensor_Gesetzt
	{
	};

// Klasse Sensor_Selbst

class Sensor_Selbst
	{
private:
	int						gesetzt;
	Vektor					richtung;	// Blickrichtung
	Punkt					p;			// Position

public:
	inline Sensor_Selbst(void) {gesetzt = 0;}
	
	inline void setzen(void) {gesetzt = 1;}
	inline int ist_gesetzt(void) const {return gesetzt;}
	
	inline void setze_richtung(const Vektor &neu) {richtung = neu;}
	inline void setze_p(Punkt neu) {p = neu;}
	
	inline Punkt frage_p(void) const {return p;}
	inline const Vektor &frage_richtung(void) const {return richtung;}
	};

// Klasse Sensorinformation

const int max_anzahl_sensorinformation = 21;
	// Maximale Anzahl gesehener Spieler

struct Sensorinformation
	{
private:
	const char *unser_teamname(void);
		
	static int linien_umrechnen(int linie);
	static int werte_linien_aus(Sensors *s,RelPos &linie_rel,int &welche_linie,
		RelPos &linie2_rel,int &welche_linie2,int &ausserhalb);
	static int flaggen_umrechnen(int flagge);
	static int werte_flaggen_aus(Sensors *s,RelPos &flagge,int &welche_flagge);
	static int werte_tore_aus(Sensors *s,RelPos &tor,int &welches_tor);
	static int werte_punkte_aus( Sensors *s,int id[10], Relative_Koordinate delta_p[10], int
&count);
	static int berechne_selbst(Sensors *s,Koordinate &S);
	void berechne_selbst(Sensors *s);

	static int berechne_relative_geschwindigkeit(RelPos &r,const Vektor &pr,Geschwindigkeit &vr);
	static int berechne_relative_koordinate(RelPos &r,Vektor &p,Winkel teta);

	void berechne_ball(Sensors *s);

	void werte_nummer_und_team_aus(Player *sp,int index);
	void werte_position_und_geschwindigkeit_aus(Player *sp,int index);
	void berechne_spieler(Player *sp);
	void berechne_spieler(Sensors *s);

public:
	Zeit					zeit;		// Zeitpunkt der Beobachtung
	
	Sensor_Selbst			selbst;		// Errechnete eigene Position
	int						anzahl;		// Anzahl gesetzter Eintrage im Array spieler.
										// Die Eintrage werden fortlaufend vom Index 0 bis anzahl - 1 besetzt
	Sensor_Spieler			spieler[max_anzahl_sensorinformation];
	Sensor_Ball				ball;
	int blockingPlayerIndex;
	Sensorinformation(Sensors *s);
	};

void update_by_sensors(Sensors *s); // Es kam neue Sensorinformation
void update_by_command(cmd_struct);



